#include "..\..\include\hge.h"

/* 
 * A plugin class extends HGE without declaring all functions
 * To extend the class, change the functions within your own class
 */
HGE * CALL Plugin_Initialize(HGE *lpHGE);

class HGE_Plugin : public HGE
{
public:
	virtual	void		CALL	Release() { m_lpHGE->Release(); };

	virtual bool		CALL	System_Initiate() { return m_lpHGE->System_Initiate(); };
	virtual void		CALL	System_Shutdown() { m_lpHGE->System_Shutdown(); };
	virtual bool		CALL	System_Start() { return m_lpHGE->System_Start(); };

	virtual char*		CALL	System_GetErrorMessage() { return m_lpHGE->System_GetErrorMessage(); };

	virtual	void		CALL	System_Log(const char *format, ...) { m_lpHGE->System_Log(format); };
	virtual bool		CALL	System_Launch(const char *url) { return m_lpHGE->System_Launch(url); };
	virtual void		CALL	System_Snapshot(const char *filename=0) { m_lpHGE->System_Snapshot(filename); };

	virtual void		CALL	System_SetStateBool  (hgeBoolState   state, bool        value) { m_lpHGE->System_SetState(state, value); };
	virtual void		CALL	System_SetStateFunc  (hgeFuncState   state, hgeCallback value) { m_lpHGE->System_SetState(state, value); };
	virtual void		CALL	System_SetStateHwnd  (hgeHwndState   state, HWINDOW     value) { m_lpHGE->System_SetState(state, value); };
	virtual void		CALL	System_SetStateInt   (hgeIntState    state, int         value) { m_lpHGE->System_SetState(state, value); };
	virtual void		CALL	System_SetStateString(hgeStringState state, const char *value) { m_lpHGE->System_SetState(state, value); };
	virtual bool		CALL	System_GetStateBool  (hgeBoolState   state) { return m_lpHGE->System_GetState(state); };
	virtual hgeCallback	CALL	System_GetStateFunc  (hgeFuncState   state) { return m_lpHGE->System_GetState(state); };
	virtual HWINDOW		CALL	System_GetStateHwnd  (hgeHwndState   state) { return m_lpHGE->System_GetState(state); };
	virtual int			CALL	System_GetStateInt   (hgeIntState    state) { return m_lpHGE->System_GetState(state); };
	virtual const char*	CALL	System_GetStateString(hgeStringState state) { return m_lpHGE->System_GetState(state); };
	
	virtual void*		CALL	Resource_Load(const char *filename, DWORD *size=0) { return m_lpHGE->Resource_Load(filename, size); };
	virtual void		CALL	Resource_Free(void *res) { m_lpHGE->Resource_Free(res); };
	virtual bool		CALL	Resource_AttachPack(const char *filename, const char *password=0) { return m_lpHGE->Resource_AttachPack(filename, password); };
	virtual void		CALL	Resource_RemovePack(const char *filename) { m_lpHGE->Resource_RemovePack(filename); };
	virtual void		CALL	Resource_RemoveAllPacks() { m_lpHGE->Resource_RemoveAllPacks(); };
	virtual char*		CALL	Resource_MakePath(const char *filename=0) { return m_lpHGE->Resource_MakePath(filename); };
	virtual char*		CALL	Resource_EnumFiles(const char *wildcard=0) { return m_lpHGE->Resource_EnumFiles(wildcard); };
	virtual char*		CALL	Resource_EnumFolders(const char *wildcard=0) { return m_lpHGE->Resource_EnumFolders(wildcard); };

	virtual	void		CALL	Ini_SetInt(const char *section, const char *name, int value) { m_lpHGE->Ini_SetInt(section, name, value); };
	virtual	int			CALL	Ini_GetInt(const char *section, const char *name, int def_val) { return m_lpHGE->Ini_GetInt(section, name, def_val); };
	virtual	void		CALL	Ini_SetFloat(const char *section, const char *name, float value) { m_lpHGE->Ini_SetFloat(section, name, value); };
	virtual	float		CALL	Ini_GetFloat(const char *section, const char *name, float def_val) { return m_lpHGE->Ini_GetFloat(section, name, def_val); };
	virtual	void		CALL	Ini_SetString(const char *section, const char *name, const char *value) { m_lpHGE->Ini_SetString(section, name, value); };
	virtual	char*		CALL	Ini_GetString(const char *section, const char *name, const char *def_val) { return m_lpHGE->Ini_GetString(section, name, def_val); };

	virtual void		CALL	Random_Seed(int seed=0) { m_lpHGE->Random_Seed(seed); };
	virtual int			CALL	Random_Int(int min, int max) { return m_lpHGE->Random_Int(min, max); };
	virtual float		CALL	Random_Float(float min, float max) { return m_lpHGE->Random_Float(min, max); };

	virtual float		CALL	Timer_GetTime() { return m_lpHGE->Timer_GetTime(); };
	virtual float		CALL	Timer_GetDelta() { return m_lpHGE->Timer_GetDelta(); };
	virtual int			CALL	Timer_GetFPS() { return m_lpHGE->Timer_GetFPS(); };

	virtual HEFFECT		CALL	Effect_Load(const char *filename, DWORD size=0) { return m_lpHGE->Effect_Load(filename, size); };
	virtual void		CALL	Effect_Free(HEFFECT eff) { m_lpHGE->Effect_Free(eff); };
	virtual HCHANNEL	CALL 	Effect_Play(HEFFECT eff) { return m_lpHGE->Effect_Play(eff); };
	virtual HCHANNEL	CALL	Effect_PlayEx(HEFFECT eff, int volume=100, int pan=0, float pitch=1.0f, bool loop=false) { return m_lpHGE->Effect_PlayEx(eff, volume, pan, pitch, loop); };

	virtual HMUSIC		CALL	Music_Load(const char *filename, DWORD size=0) { return m_lpHGE->Music_Load(filename, size); };
	virtual void		CALL	Music_Free(HMUSIC mus) { m_lpHGE->Music_Free(mus); };
	virtual HCHANNEL	CALL	Music_Play(HMUSIC mus, bool loop, int volume = 100, int order = -1, int row = -1) { return m_lpHGE->Music_Play(mus, loop, volume, order, row); };
	virtual void		CALL	Music_SetAmplification(HMUSIC music, int ampl) { m_lpHGE->Music_SetAmplification(music, ampl); };
	virtual int			CALL	Music_GetAmplification(HMUSIC music) { return m_lpHGE->Music_GetAmplification(music); };
	virtual int			CALL	Music_GetLength(HMUSIC music) { return m_lpHGE->Music_GetLength(music); };
	virtual void		CALL	Music_SetPos(HMUSIC music, int order, int row) { m_lpHGE->Music_SetPos(music, order, row); };
	virtual bool		CALL	Music_GetPos(HMUSIC music, int *order, int *row) { return m_lpHGE->Music_GetPos(music, order, row); };
	virtual void		CALL	Music_SetInstrVolume(HMUSIC music, int instr, int volume) { m_lpHGE->Music_SetInstrVolume(music, instr, volume); };
	virtual int			CALL	Music_GetInstrVolume(HMUSIC music, int instr) { return m_lpHGE->Music_GetInstrVolume(music, instr); };
	virtual void		CALL	Music_SetChannelVolume(HMUSIC music, int channel, int volume) { m_lpHGE->Music_SetChannelVolume(music, channel, volume); };
	virtual int			CALL	Music_GetChannelVolume(HMUSIC music, int channel) { return m_lpHGE->Music_GetChannelVolume(music, channel); };

	virtual HSTREAM		CALL	Stream_Load(const char *filename, DWORD size=0) { return m_lpHGE->Stream_Load(filename, size); };
	virtual void		CALL	Stream_Free(HSTREAM stream) { m_lpHGE->Stream_Free(stream); };
	virtual HCHANNEL	CALL	Stream_Play(HSTREAM stream, bool loop, int volume = 100) { return m_lpHGE->Stream_Play(stream, loop, volume); };

	virtual void		CALL	Channel_SetPanning(HCHANNEL chn, int pan) { m_lpHGE->Channel_SetPanning(chn, pan); };
	virtual void		CALL 	Channel_SetVolume(HCHANNEL chn, int volume) { m_lpHGE->Channel_SetVolume(chn, volume); };
	virtual void		CALL 	Channel_SetPitch(HCHANNEL chn, float pitch) { m_lpHGE->Channel_SetPitch(chn, pitch); };
	virtual void		CALL 	Channel_Pause(HCHANNEL chn) { m_lpHGE->Channel_Pause(chn); };
	virtual void		CALL 	Channel_Resume(HCHANNEL chn) { m_lpHGE->Channel_Resume(chn); };
	virtual void		CALL 	Channel_Stop(HCHANNEL chn) { m_lpHGE->Channel_Stop(chn); };
	virtual void		CALL 	Channel_PauseAll() { m_lpHGE->Channel_PauseAll(); };
	virtual void		CALL 	Channel_ResumeAll() { m_lpHGE->Channel_ResumeAll(); };
	virtual void		CALL 	Channel_StopAll() { m_lpHGE->Channel_StopAll(); };
	virtual bool		CALL	Channel_IsPlaying(HCHANNEL chn) { return m_lpHGE->Channel_IsPlaying(chn); };
	virtual float		CALL	Channel_GetLength(HCHANNEL chn) { return m_lpHGE->Channel_GetLength(chn); };
	virtual float		CALL	Channel_GetPos(HCHANNEL chn) { return m_lpHGE->Channel_GetPos(chn); };
	virtual void		CALL	Channel_SetPos(HCHANNEL chn, float fSeconds) { m_lpHGE->Channel_SetPos(chn, fSeconds); };
	virtual void		CALL	Channel_SlideTo(HCHANNEL channel, float time, int volume, int pan = -101, float pitch = -1) { m_lpHGE->Channel_SlideTo(channel, time, volume, pan, pitch); };
	virtual bool		CALL	Channel_IsSliding(HCHANNEL channel) { return m_lpHGE->Channel_IsSliding(channel); };

	virtual void		CALL	Input_GetMousePos(float *x, float *y) { m_lpHGE->Input_GetMousePos(x, y); };
	virtual void		CALL	Input_SetMousePos(float x, float y) { m_lpHGE->Input_SetMousePos(x, y); };
	virtual int			CALL	Input_GetMouseWheel() { return m_lpHGE->Input_GetMouseWheel(); };
	virtual bool		CALL	Input_IsMouseOver() { return m_lpHGE->Input_IsMouseOver(); };
	virtual bool		CALL	Input_KeyDown(int key) { return m_lpHGE->Input_KeyDown(key); };
	virtual bool		CALL	Input_KeyUp(int key) { return m_lpHGE->Input_KeyUp(key); };
	virtual bool		CALL	Input_GetKeyState(int key) { return m_lpHGE->Input_GetKeyState(key); };
	virtual char*		CALL	Input_GetKeyName(int key) { return m_lpHGE->Input_GetKeyName(key); };
	virtual int			CALL	Input_GetKey() { return m_lpHGE->Input_GetKey(); };
	virtual int			CALL	Input_GetChar() { return m_lpHGE->Input_GetChar(); };
	virtual bool		CALL	Input_GetEvent(hgeInputEvent *event) { return m_lpHGE->Input_GetEvent(event); };

	virtual bool		CALL	Gfx_BeginScene(HTARGET target=0) { return m_lpHGE->Gfx_BeginScene(target); };
	virtual void		CALL	Gfx_EndScene() { m_lpHGE->Gfx_EndScene(); };
	virtual void		CALL	Gfx_Clear(DWORD color) { m_lpHGE->Gfx_Clear(color); };
	virtual void		CALL	Gfx_RenderLine(float x1, float y1, float x2, float y2, DWORD color=0xFFFFFFFF, float z=0.5f) { m_lpHGE->Gfx_RenderLine(x1, y1, x2, y2, color, z); };
	virtual void		CALL	Gfx_RenderTriple(const hgeTriple *triple) { m_lpHGE->Gfx_RenderTriple(triple); };
	virtual void		CALL	Gfx_RenderQuad(const hgeQuad *quad) { m_lpHGE->Gfx_RenderQuad(quad); };
	virtual hgeVertex*	CALL	Gfx_StartBatch(int prim_type, HTEXTURE tex, int blend, int *max_prim) { return m_lpHGE->Gfx_StartBatch(prim_type, tex, blend, max_prim); };
	virtual void		CALL	Gfx_FinishBatch(int nprim) { m_lpHGE->Gfx_FinishBatch(nprim); };
	virtual void		CALL	Gfx_SetClipping(int x=0, int y=0, int w=0, int h=0) { m_lpHGE->Gfx_SetClipping(x, y, w, h); };
	virtual void		CALL	Gfx_SetTransform(float x=0, float y=0, float dx=0, float dy=0, float rot=0, float hscale=0, float vscale=0) { m_lpHGE->Gfx_SetTransform(x, y, dx, dy, rot, hscale, vscale); }; 

	virtual HSHADER		CALL	Shader_Create(const char *filename, const char *function = "ps_main", const char *profile = "ps_2_0") { return m_lpHGE->Shader_Create(filename, function, profile); };
	virtual void		CALL	Shader_Free(HSHADER shader) { m_lpHGE->Shader_Free(shader); };
	virtual void		CALL	Gfx_SetShader(HSHADER shader) { m_lpHGE->Gfx_SetShader(shader); };

	virtual HTARGET		CALL	Target_Create(int width, int height, bool zbuffer) { return m_lpHGE->Target_Create(width, height, zbuffer); };
	virtual void		CALL	Target_Free(HTARGET target) { m_lpHGE->Target_Free(target); };
	virtual HTEXTURE	CALL	Target_GetTexture(HTARGET target) { return m_lpHGE->Target_GetTexture(target); };

	virtual HTEXTURE	CALL	Texture_Create(int width, int height) { return m_lpHGE->Texture_Create(width, height); };
	virtual HTEXTURE	CALL	Texture_Load(const char *filename, DWORD size=0, bool bMipmap=false) { return m_lpHGE->Texture_Load(filename, size, bMipmap); };
	virtual void		CALL	Texture_Free(HTEXTURE tex) { m_lpHGE->Texture_Free(tex); };
	virtual int			CALL	Texture_GetWidth(HTEXTURE tex, bool bOriginal=false) { return m_lpHGE->Texture_GetWidth(tex, bOriginal); };
	virtual int			CALL	Texture_GetHeight(HTEXTURE tex, bool bOriginal=false) { return m_lpHGE->Texture_GetHeight(tex, bOriginal); };
	virtual DWORD*		CALL	Texture_Lock(HTEXTURE tex, bool bReadOnly=true, int left=0, int top=0, int width=0, int height=0) { return m_lpHGE->Texture_Lock(tex, bReadOnly, left, top, width, height); };
	virtual void		CALL	Texture_Unlock(HTEXTURE tex) { m_lpHGE->Texture_Unlock(tex); };

	virtual void		CALL	Plugin_Load(int type, const char *filename) { m_lpHGE->Plugin_Load(type, filename); };
	virtual void		CALL	Plugin_Free(int type) { m_lpHGE->Plugin_Free(type); };

protected:
	HGE *m_lpHGE;
};